=== added directory 'annis-gui'
=== added file 'annis-gui/pom.xml'
--- annis-gui/pom.xml	1970-01-01 00:00:00 +0000
+++ annis-gui/pom.xml	2011-09-02 15:55:46 +0000
@@ -0,0 +1,133 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd">
+  <modelVersion>4.0.0</modelVersion>
+  <parent>
+    <artifactId>annis-all</artifactId>
+    <groupId>de.hu-berlin.german.korpling.annis</groupId>
+    <version>2.3.0-SNAPSHOT</version>
+  </parent>
+  <groupId>annis.gui</groupId>
+  <artifactId>annis-gui</artifactId>
+  <packaging>war</packaging>
+  <version>2.3.0-SNAPSHOT</version>
+
+  <properties>
+    <project.build.sourceEncoding>US-ASCII</project.build.sourceEncoding>
+    <vaadin.version>6.6.5</vaadin.version>
+    <gwt.version>2.3.0</gwt.version>
+    <gwt.plugin.version>2.2.0</gwt.plugin.version>
+  </properties>
+
+  <build>
+    <plugins>
+      <plugin>
+        <groupId>org.apache.maven.plugins</groupId>
+        <artifactId>maven-compiler-plugin</artifactId>
+        <configuration>
+          <source>1.6</source>
+          <target>1.6</target>
+        </configuration>
+      </plugin>
+
+
+      <!-- A simple Jetty test server at http://localhost:8080/annis-gui can be launched with the Maven goal jetty:run 
+        and stopped with jetty:stop -->
+      <plugin>
+        <groupId>org.mortbay.jetty</groupId>
+        <artifactId>maven-jetty-plugin</artifactId>
+        <version>6.1.24</version>
+        <configuration>
+          <stopPort>9966</stopPort>
+          <stopKey>annis-gui</stopKey>
+          <!-- Redeploy every x seconds if changes are detected, 0 for no automatic redeployment -->
+          <scanIntervalSeconds>0</scanIntervalSeconds>
+          <!-- make sure Jetty also finds the widgetset -->
+          <webAppConfig>
+            <contextPath>/annis-gui</contextPath>
+            <baseResource implementation="org.mortbay.resource.ResourceCollection">
+              <!-- Workaround for Maven/Jetty issue http://jira.codehaus.org/browse/JETTY-680 -->
+              <!-- <resources>src/main/webapp,${project.build.directory}/${project.build.finalName}</resources> -->
+              <resourcesAsCSV>src/main/webapp,${project.build.directory}/${project.build.finalName}</resourcesAsCSV>
+            </baseResource>
+          </webAppConfig>
+        </configuration>
+      </plugin>
+    </plugins>
+  </build>
+
+  <repositories>
+    <!--
+    <repository>
+      <id>vaadin-addons</id>
+      <url>http://maven.vaadin.com/vaadin-addons</url>
+    </repository>
+    -->
+    <repository>
+      <id>korpling</id>
+      <url>http://korpling.german.hu-berlin.de/maven2/</url>
+    </repository>
+    
+  </repositories>
+
+  <!--
+  <pluginRepositories>
+    <pluginRepository>
+      <id>codehaus-snapshots</id>
+      <url>http://nexus.codehaus.org/snapshots</url>
+      <snapshots>
+        <enabled>true</enabled>
+      </snapshots>
+      <releases>
+        <enabled>false</enabled>
+      </releases>
+    </pluginRepository>
+    <pluginRepository>
+      <id>vaadin-snapshots</id>
+      <url>http://oss.sonatype.org/content/repositories/vaadin-snapshots/</url>
+      <snapshots>
+        <enabled>true</enabled>
+      </snapshots>
+      <releases>
+        <enabled>false</enabled>
+      </releases>
+    </pluginRepository>
+  </pluginRepositories>
+  -->
+
+  <dependencies>
+    <dependency>
+      <groupId>com.vaadin</groupId>
+      <artifactId>vaadin</artifactId>
+      <version>${vaadin.version}</version>
+    </dependency>
+    
+    <dependency>
+      <groupId>com.vaadin.addon</groupId>
+      <artifactId>vaadin-chameleon-theme</artifactId>
+      <version>1.1.0</version>
+    </dependency>
+    
+    <!--
+    <dependency>
+      <groupId>com.google.gwt</groupId>
+      <artifactId>gwt-user</artifactId>
+      <version>${gwt.version}</version>
+      <scope>provided</scope>
+    </dependency>
+    <dependency>
+      <groupId>javax.validation</groupId>
+      <artifactId>validation-api</artifactId>
+      <version>1.0.0.GA</version>
+      <scope>provided</scope>
+    </dependency>
+    <dependency>
+      <groupId>javax.validation</groupId>
+      <artifactId>validation-api</artifactId>
+      <version>1.0.0.GA</version>
+      <classifier>sources</classifier>
+      <scope>provided</scope>
+	</dependency>
+    -->
+  </dependencies>
+  <name>Annis GUI</name>
+</project>

=== added directory 'annis-gui/src'
=== added directory 'annis-gui/src/main'
=== added directory 'annis-gui/src/main/java'
=== added directory 'annis-gui/src/main/java/annis'
=== added directory 'annis-gui/src/main/java/annis/gui'
=== added file 'annis-gui/src/main/java/annis/gui/MainApp.java'
--- annis-gui/src/main/java/annis/gui/MainApp.java	1970-01-01 00:00:00 +0000
+++ annis-gui/src/main/java/annis/gui/MainApp.java	2011-09-02 15:55:46 +0000
@@ -0,0 +1,72 @@
+/*
+ * Copyright 2011 Corpuslinguistic working group Humboldt University Berlin
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *    http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package annis.gui;
+
+import annis.gui.controlpanel.ControlPanel;
+import com.vaadin.Application;
+import com.vaadin.ui.Button;
+import com.vaadin.ui.Button.ClickEvent;
+import com.vaadin.ui.HorizontalLayout;
+import com.vaadin.ui.Label;
+import com.vaadin.ui.Layout;
+import com.vaadin.ui.MenuBar;
+import com.vaadin.ui.MenuBar.MenuItem;
+import com.vaadin.ui.VerticalLayout;
+import com.vaadin.ui.Window;
+
+/**
+ * The Application's "main" class
+ */
+@SuppressWarnings("serial")
+public class MainApp extends Application
+{
+
+  private Window window;
+
+  @Override
+  public void init()
+  {
+    setTheme("annis-theme");
+    
+    window = new Window("Annis GUI");
+    setMainWindow(window);
+    
+    window.getContent().setSizeFull();
+    
+    MenuBar menu = new MenuBar();
+    menu.addItem("Test", new MenuBar.Command() {
+
+      @Override
+      public void menuSelected(MenuItem selectedItem)
+      {
+        window.showNotification("Just a dummy", Window.Notification.TYPE_HUMANIZED_MESSAGE);
+      }
+    });
+    
+    window.addComponent(menu);
+    menu.setWidth(100f, Layout.UNITS_PERCENTAGE);
+    
+    HorizontalLayout hLayout = new HorizontalLayout();
+    hLayout.setSizeFull();
+    window.addComponent(hLayout);
+    ((VerticalLayout) window.getContent()).setExpandRatio(hLayout, 1.0f);
+
+    
+    hLayout.addComponent(new ControlPanel());
+    hLayout.addComponent(new Label("TODO"));
+    
+  }
+}
\ No newline at end of file

=== added directory 'annis-gui/src/main/java/annis/gui/controlpanel'
=== added file 'annis-gui/src/main/java/annis/gui/controlpanel/ControlPanel.java'
--- annis-gui/src/main/java/annis/gui/controlpanel/ControlPanel.java	1970-01-01 00:00:00 +0000
+++ annis-gui/src/main/java/annis/gui/controlpanel/ControlPanel.java	2011-09-02 15:55:46 +0000
@@ -0,0 +1,37 @@
+/*
+ * Copyright 2011 Corpuslinguistic working group Humboldt University Berlin.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+package annis.gui.controlpanel;
+
+import com.vaadin.terminal.gwt.server.WebBrowser;
+import com.vaadin.ui.Label;
+import com.vaadin.ui.Layout;
+import com.vaadin.ui.Panel;
+
+/**
+ *
+ * @author thomas
+ */
+public class ControlPanel extends Panel
+{
+  public ControlPanel()
+  {
+    setWidth(345f, Layout.UNITS_PIXELS);    
+    setHeight(100, Layout.UNITS_PERCENTAGE);
+    
+    addStyleName("control");
+    addComponent(new Label("background should be orange"));
+  }
+}

=== added directory 'annis-gui/src/main/resources'
=== added directory 'annis-gui/src/main/webapp'
=== added directory 'annis-gui/src/main/webapp/META-INF'
=== added file 'annis-gui/src/main/webapp/META-INF/MANIFEST.MF'
--- annis-gui/src/main/webapp/META-INF/MANIFEST.MF	1970-01-01 00:00:00 +0000
+++ annis-gui/src/main/webapp/META-INF/MANIFEST.MF	2011-09-02 15:55:46 +0000
@@ -0,0 +1,3 @@
+Manifest-Version: 1.0
+Class-Path: 
+

=== added file 'annis-gui/src/main/webapp/META-INF/context.xml'
--- annis-gui/src/main/webapp/META-INF/context.xml	1970-01-01 00:00:00 +0000
+++ annis-gui/src/main/webapp/META-INF/context.xml	2011-09-02 15:55:46 +0000
@@ -0,0 +1,2 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<Context antiJARLocking="true" path="/annis-gui-2.3.0-SNAPSHOT"/>

=== added directory 'annis-gui/src/main/webapp/VAADIN'
=== added directory 'annis-gui/src/main/webapp/VAADIN/themes'
=== added directory 'annis-gui/src/main/webapp/VAADIN/themes/annis-theme'
=== added file 'annis-gui/src/main/webapp/VAADIN/themes/annis-theme/styles.css'
--- annis-gui/src/main/webapp/VAADIN/themes/annis-theme/styles.css	1970-01-01 00:00:00 +0000
+++ annis-gui/src/main/webapp/VAADIN/themes/annis-theme/styles.css	2011-09-02 15:55:46 +0000
@@ -0,0 +1,340 @@
+@import "../chameleon/styles.css";
+
+/** 
+ * "optional-" prefix means that the style is not necessarily used, it can be left blank
+ * "generated-" prefix means that the style is calculated from some other color, and not directly selected by the editor user
+ *
+ **/
+
+.control .v-panel-content {
+  background-color: #DCE5EE; 
+}
+
+/* Application background */
+.v-app {
+	background: rgb(249,249,249);
+	}
+
+.v-window,
+.v-popupview-popup,
+.v-filterselect-suggestpopup,
+.v-datefield-popup,
+.v-contextmenu,
+.v-Notification,
+.v-menubar-submenu {
+	background-color: rgb(249,249,249);
+	background-color: rgba(249,249,249,.85);
+	}
+
+body.v-ie6 .v-window,
+body.v-ie7 .v-window,
+body.v-ie6 .v-popupview-popup,
+body.v-ie7 .v-popupview-popup,
+body.v-ie6 .v-filterselect-suggestpopup,
+body.v-ie7 .v-filterselect-suggestpopup,
+body.v-ie6 .v-datefield-popup,
+body.v-ie7 .v-datefield-popup,
+body.v-ie6 .v-contextmenu,
+body.v-ie7 .v-contextmenu,
+body.v-ie6 .v-menubar-submenu,
+body.v-ie7 .v-menubar-submenu,
+.v-panel-content,
+.v-panel-bubble .v-panel-captionwrap,
+.v-panel-bubble .v-panel-deco-bubble,
+.v-tabsheet-content,
+.v-tabsheet-tabitem-selected,
+.v-slider-base,
+.v-window-modalitycurtain,
+.v-window-opaque,
+.v-progressindicator-wrapper,
+.v-accordion-item-caption,
+.v-accordion-item-open .v-accordion-item-caption:active,
+.v-accordion-opaque div.v-accordion-item-open,
+.v-table-scrollposition,
+.v-table-body {
+	background-color: rgb(249,249,249);
+	}
+
+/* Base font size and color */
+.v-app,
+.v-window,
+.v-popupview-popup,
+.v-app input,
+.v-app button,
+.v-app textarea,
+.v-window input,
+.v-window button,
+.v-window textarea,
+.v-popupview-popup input,
+.v-popupview-popup button,
+.v-popupview-popup textarea,
+.v-filterselect-suggestpopup,
+.v-datefield-popup,
+.v-datefield-calendarpanel-header button,
+.v-contextmenu,
+.v-Notification,
+.v-menubar-submenu,
+.v-table-header-drag,
+.v-filterselect-select-button .v-filterselect-input,
+.v-drag-element {
+	font-size: 13px;
+	color: rgb(34,34,34);
+	}
+
+.v-app select,
+.v-window select,
+.v-popupview-popup select,
+.v-datefield-popup select {
+	font-size: 13px;
+	}
+
+.v-label,
+.sidebar-menu .v-label,
+.v-table-scrollposition {
+	@optional-generated-shadow@
+	}
+
+/* Base background color */
+.v-button:active,
+.v-ie .v-button.v-pressed,
+div.v-button-down,
+.v-slider .v-slider-handle-active {
+	background-color: rgb(161,161,161);
+	border-color: rgb(103,103,103);
+	}
+
+div.v-button-down:active {
+	background-color: rgb(129,129,129);
+	}
+	
+.v-button:focus {
+	background-color: rgb(161,161,161);
+	}
+
+/* Base border color */
+.v-button:active .v-button-wrap,
+.v-ie .v-button.v-pressed .v-button-wrap,
+.v-button-down .v-button-wrap,
+.v-datefield-calendarpanel-header td,
+.v-slider-base,
+.v-tabsheet-scrollerNext,
+.v-tabsheet-scrollerNext-disabled,
+.v-tabsheet-scrollerNext-disabled:active,
+.v-table-header-wrap,
+.v-table-body,
+.v-table-resizer,
+div.v-table-focus-slot-left,
+div.v-table-focus-slot-right,
+input.v-textfield,
+textarea.v-textarea,
+.v-filterselect {
+	border-color: rgb(129,129,129);
+	}
+
+
+input.v-textfield,
+textarea.v-textarea,
+.v-filterselect {
+	border-bottom-color: rgb(161,161,161);
+	border-left-color: rgb(161,161,161);
+	border-right-color: rgb(161,161,161);
+	}
+
+.v-button,
+.v-disabled.v-button:focus,
+.v-disabled.v-button:active,
+.v-datefield-button,
+.v-datefield-calendarpanel-header button,
+td.v-datefield-calendarpanel-month,
+.v-datefield-calendarpanel-weekdays strong,
+.v-slider-handle,
+.v-table-header-wrap,
+.v-table-header-drag,
+.v-filterselect-prevpage-off,
+.v-filterselect-nextpage-off,
+.v-filterselect-prevpage,
+.v-filterselect-nextpage,
+.v-filterselect-select-button,
+.v-splitpanel-hsplitter,
+.v-splitpanel-vsplitter,
+.v-splitpanel-hsplitter-locked,
+.v-splitpanel-vsplitter-locked,
+.v-accordion-opaque,
+.v-accordion-opaque .v-accordion-item-open,
+.v-accordion-opaque .v-accordion-item-caption,
+.v-accordion-opaque .v-accordion-item-open .v-accordion-item-caption:active,
+.v-tabsheet-scroller,
+.v-csslayout-toolbar,
+.v-menubar {
+	background-color: rgb(201,201,201);
+	border-color: rgb(129,129,129);
+	}
+
+.v-button .v-button-wrap,
+.v-disabled.v-button:focus .v-button-wrap,
+.v-disabled.v-button:active .v-button-wrap,
+.v-datefield-calendarpanel-header button,
+td.v-datefield-calendarpanel-month,
+.v-window-wrap,
+.v-popupview-popup,
+.v-filterselect-suggestpopup,
+.v-datefield-popup,
+.v-contextmenu,
+.v-menubar-submenu,
+.v-panel-bubble .v-panel-caption-bubble,
+.v-slider-handle,
+.v-tabsheet-tabitem-selected .v-caption,
+.v-table-header-wrap,
+.v-table-header-drag,
+.v-filterselect-prevpage-off,
+.v-filterselect-nextpage-off,
+.v-filterselect-prevpage,
+.v-filterselect-nextpage,
+.v-filterselect-select-button,
+.v-progressindicator-indicator,
+.v-accordion-item-caption,
+.v-accordion-item-open .v-accordion-item-caption:active,
+.v-tabsheet-scroller,
+.v-csslayout-toolbar,
+.v-menubar {
+	
+	}
+
+.v-datefield-calendarpanel-weekdays strong,
+.v-splitpanel-hsplitter-small,
+.v-splitpanel-vsplitter-small,
+.v-splitpanel-hsplitter-small-locked,
+.v-splitpanel-vsplitter-small-locked {
+	background-color: rgb(161,161,161);
+	}
+
+.v-progressindicator-wrapper {
+	border-color: rgb(161,161,161);
+	}
+
+.v-button,
+.v-disabled.v-button:focus,
+.v-disabled.v-button:active,
+.v-datefield-calendarpanel-header button,
+td.v-datefield-calendarpanel-month,
+.v-tabsheet-tabitem-selected .v-caption,
+.v-window-header,
+.v-table-caption-container,
+.v-accordion-item-caption,
+.v-menubar .v-menubar-menuitem,
+.v-filterselect-select-button .v-filterselect-input {
+	text-shadow: 0 1px 0 rgb(223,223,223);
+	}
+
+/* Background border color */
+.v-window,
+.v-popupview-popup,
+.v-filterselect-suggestpopup,
+.v-datefield-popup,
+.v-contextmenu,
+.v-Notification,
+.v-menubar-submenu,
+.v-panel-caption,
+.v-panel-nocaption,
+.v-panel-content,
+.v-panel-deco,
+.v-panel-light .v-panel-caption-light,
+.v-panel-bubble .v-panel-captionwrap,
+.v-panel-bubble .v-panel-content-bubble,
+.v-panel-bubble .v-panel-deco-bubble,
+.v-tabsheet-tabitem-selected,
+.v-tabsheet-tabitem,
+.v-tabsheet-spacertd div,
+.v-tabsheet-content,
+.v-tabsheet-deco,
+.v-slider,
+.v-splitpanel-hsplitter,
+.v-splitpanel-vsplitter,
+.v-splitpanel-hsplitter-locked,
+.v-splitpanel-vsplitter-locked,
+.v-table-scrollposition,
+.v-accordion,
+.v-accordion-item-caption,
+.v-accordion-item-open,
+.v-menubar-separator span {
+	border-color: rgb(199,199,199);
+	}
+
+/* Alternate colors */
+.v-label-color,
+.v-button-link,
+.v-button-link:focus,
+.v-button-link:active,
+.v-disabled.v-button-link,
+.v-disabled.v-button-link:focus,
+.v-app a,
+.v-popupview-popup a,
+.v-popupview,
+.sidebar-menu .v-label {
+	color: rgb(40,126,206);
+	}
+
+.v-button-default,
+.v-disabled.v-button-default,
+.v-disabled.v-button-default:focus,
+.v-button-default:active,
+.v-ie7 .v-button-default.v-pressed,
+.v-ie8 .v-button-default.v-pressed,
+.sidebar-menu .tab-selected,
+.sidebar-menu .selected,
+.v-horizontallayout-segment-alternate .v-button-down {
+	border-color: rgb(46,90,132);
+	}
+
+.v-button-default:focus,
+.v-horizontallayout-segment-alternate .v-button-down:active {
+	background-color: rgb(45,107,165);
+	}
+
+.v-button-default:active .v-button-wrap,
+.v-ie7 .v-button-default.v-pressed .v-button-wrap,
+.v-ie8 .v-button-default.v-pressed .v-button-wrap,
+.v-progressindicator-indicator,
+.v-datefield-calendarpanel-day:hover,
+.v-horizontallayout-segment-alternate .v-button-down .v-button-wrap {
+	border-color: rgb(45,107,165);
+	}
+
+.v-button-default,
+.v-disabled.v-button-default,
+.v-disabled.v-button-default:focus,
+.v-button-default:active,
+.v-ie7 .v-button-default.v-pressed,
+.v-ie8 .v-button-default.v-pressed,
+.v-panel-bubble .v-panel-caption,
+.v-datefield-calendarpanel-day-selected,
+.v-table tr.v-selected,
+.v-contextmenu .gwt-MenuItem-selected,
+.v-contextmenu .gwt-MenuItem-selected div,
+.v-filterselect-suggestpopup .gwt-MenuItem-selected,
+.v-progressindicator-indicator,
+.v-tree-node-selected span,
+.sidebar-menu .tab-selected,
+.sidebar-menu .selected,
+.v-horizontallayout-segment-alternate .v-button-down,
+.v-menubar .v-menubar-menuitem-selected,
+.v-menubar-submenu .v-menubar-menuitem-selected {
+	background-color: rgb(40,126,206);
+	color: rgb(247,248,249);
+	text-shadow: 0 -1px 0 rgb(46,90,132);
+	}
+
+.v-ie6 .v-progressindicator-indicator {
+	background-color: rgb(40,126,206);
+	}
+
+.v-panel-caption,
+.v-table-striped .v-table-row-odd,
+.sidebar-menu {
+	background: rgb(220,229,238);
+	}
+
+.sidebar-menu .tab-selected,
+.sidebar-menu .selected {
+	text-shadow: 0 1px 0 rgb(46,90,132);
+	}
\ No newline at end of file

=== added directory 'annis-gui/src/main/webapp/WEB-INF'
=== added file 'annis-gui/src/main/webapp/WEB-INF/web.xml'
--- annis-gui/src/main/webapp/WEB-INF/web.xml	1970-01-01 00:00:00 +0000
+++ annis-gui/src/main/webapp/WEB-INF/web.xml	2011-09-02 15:55:46 +0000
@@ -0,0 +1,21 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<web-app xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://java.sun.com/xml/ns/javaee" xmlns:web="http://java.sun.com/xml/ns/javaee/web-app_2_5.xsd" xsi:schemaLocation="http://java.sun.com/xml/ns/javaee http://java.sun.com/xml/ns/javaee/web-app_2_5.xsd" id="WebApp_ID" version="2.5">
+    <display-name>Vaadin Web Application</display-name>
+    <context-param>
+        <description>Vaadin production mode</description>
+        <param-name>productionMode</param-name>
+        <param-value>false</param-value>
+    </context-param>
+    <servlet>
+        <servlet-name>MainApp</servlet-name>
+        <servlet-class>com.vaadin.terminal.gwt.server.ApplicationServlet</servlet-class>
+        <init-param>
+            <param-name>application</param-name>
+            <param-value>annis.gui.MainApp</param-value>
+        </init-param>
+    </servlet>
+    <servlet-mapping>
+        <servlet-name>MainApp</servlet-name>
+        <url-pattern>/*</url-pattern>
+    </servlet-mapping>
+</web-app>
\ No newline at end of file

=== modified file 'pom.xml'
--- pom.xml	2011-08-24 14:33:38 +0000
+++ pom.xml	2011-09-02 15:55:46 +0000
@@ -29,6 +29,7 @@
     <module>Annis-Service</module>
     <module>Annis-Web</module>
     <module>Annis-Kickstarter</module>
+    <module>annis-gui</module>
   </modules>
 
-</project>
+</project>
\ No newline at end of file

